/* HoWSample.r.h - header for HoWSample resources */

/* to compile: BuildProgram HoWS */

/* - - - - - - - - - - - an AWOL Software Production - - - - - - - - - - - */
/* - - - - - - - - - - - - - (c) 1994 Ross Brown - - - - - - - - - - - - - */
/* - - - - - - - - -  Email:  ab026@freenet.carleton.ca  - - - - - - - - - */

/* constants */

#define	cTagSpacing	100	/* multiply by dialog or menu number and add item to get help tag number */

/* general resources */

#define	rMenuBar	128	/* application's menu bar */

#define	rAboutAlert	128	/* about alert */
#define	rGeneralAlert	129	/* general alert */
#define	rDoNothingDialog	130	/* do-nothing dialog */

#define	rPrincipalIconFamily	128	/* principal icon family */
#define	rPreferencesIconFamily	129	/* icon family for preferences file */

#define	rHelpFileAlias	128	/* alias to help file */

#define	rMessages	128	/* list of message strings */
#define	rPreloadStrings	129	/* list of preload strings */

#define	rJokeSound	128	/* joke sound */

/* menu resources */

#define	mApple	256	/* Apple menu */
#define	iAbout	1

#define	mFile	257	/* File menu */
#define	iQuit	1

#define	mEdit	258	/* Edit menu */
#define	iUndo	1
#define	iCut	3
#define	iCopy	4
#define	iPaste	5
#define	iClear	6

#define	mDemo	259	/* Demo menu */
#define	iDoNothing	1

/* Help menu */
#define	iHoWSampleHelp	1
#define	iDialogHelp	3
#define	iMenuHelp	4

/* dialog item resources */

/* items in rDoNothingDialog */
#define	iDNDSqueak	1

/* items in rMessages - positive (with strings) */
#define	iGenericErrorMessage	1
#define	iHelpNotAvailable	2
#define	iHoWSampleRequiresAppleEvents	3
#define	iHoWSampleRequiresFolderManager	4
#define	iHoWSampleRequiresProcessManager	5
#define	iHoWSampleRequiresAliasManager	6
#define	iHoWSampleRequiresEnhancedStandardFile	7
#define	iHoWSampleRequiresWaitNextEvent	8
#define	iHoWRegisterFailed	9
#define	iPreferencesFileUnwritable	10
#define	iHoWSampleRequiresFSSpecCalls	11
#define iHelpFileWrongVersion   12
#define	iPreferencesFileUnreadable	13

/* items in rMessages - negative (without strings, internal errors) */
#define	iCantDisplayHelp	(-1)
#define	iCantFindPreferencesFolder	(-2)
#define	iCantAccessPreferencesFile	(-3)
#define	iCantResolvePreferencesFileAlias	(-4)
#define	iCantCreatePreferencesFile	(-5)
#define	iCantGetPreloadString	(-6)

/* items in rPreloadStrings */
#define	iHoWSamplePreferencesFileName	1
#define	iHoWSampleHelpFileName	2
#define	iHelpCommandChar	3
#define	iDialogHelpString	4
#define	iMenuHelpString	5
