//
// CMiniTelnetApp.h
//
//	MiniTelnet application
//	Application subclass
//	PowerPlant version
//
//	Copyright  1993-95, FrostByte Design / Eric Scouten
//

#pragma once

#include <LDocApplication.h>
#include <LListener.h>
#include "CTCPApplicationPP.h"

#include "MiniTelnet.const.h"


//***********************************************************

class CMiniTelnetApp : public LDocApplication, public CTCPApplicationPP, public LListener {

// This application originates Telnet sessions and responds to the application-wide menus.

public:
						CMiniTelnetApp();
	
	// creation of Telnet sessions (documents)

	virtual LModelObject*	MakeNewDocument();
	virtual void			OpenDocument(FSSpec* inMacFSSpec);
	virtual void			OpenSettings(FSSpec* inMacFSSpec);
	virtual void 			OpenSettingsFile(FSSpec* inMacFSSpec, TelnetSettingsRec* theSettings);
	virtual void			NewSession(TelnetSettingsRec& newSettings);
	
	// menu/command handling

	virtual void			ListenToMessage(MessageT inMessage, void* ioParam);
	virtual Boolean			ObeyCommand(CommandT	inCommand, void* ioParam);
	virtual void			FindCommandStatus(CommandT inCommand, Boolean& outEnabled, Boolean& outUsesMark,
							Char16& outMark, Str255 outName);
	virtual void			ChooseDocument();

};
