//
// MiniTelnet.const.h
//
//	MiniTelnet application
//	Constants used by application
//	PowerPlant version
//
//	Copyright  1993-95, FrostByte Design / Eric Scouten
//

#pragma once


//***********************************************************
// MiniTelnet file parameters

#define kAppSignature		'dTCP'
#define kSettingsFileType		'dTSR'


//***********************************************************
// memory size information

#define kExtraMasters		4				// adjust based on observations
#define kRainyDayFund		20480
#define kCriticalBalance		20480
#define kToolboxBalance		20480


//***********************************************************
// Telnet connection parameters

#define kTelnetPort			23U
#define kTelnetRecBufferSize	16384L
#define kTelnetAutoRecSize	4
#define kTelnetAutoRecNum	4


//***********************************************************
// resource IDs

#define DLOGAboutBox		1098
#define PPobTelnetSettings	2800

//***********************************************************

	// command numbers

	enum {
		cmd_OpenSettings = 2000,			// File menu
	
		cmd_SendSynch = 2100,				// Telnet menu
		cmd_SendBreak = 2101,
		cmd_SendAO = 2102,
		cmd_SendIP = 2103,
		cmd_SendAYT = 2104,
		cmd_SendGA = 2105,
		cmd_SendEC = 2110,
		cmd_SendEL = 2111,
		cmd_SendIPAddr = 2120,
		cmd_ShowDebug = 2199,
		
		msg_SaveSettings = 2800,			// Settings dialog
		msg_OpenSession = 2810
	};

//***********************************************************

// miscellaneous constants

#define kSplashScreenTicks	180				// how long to display splash screen (3 seconds)
#define telnetPort			23

//***********************************************************

// terminal emulation modes

enum TermNumber {
	termUnknown = 0,
	termMax								// highest terminal # defined
};
typedef enum TermNumber TermNumber;

//***********************************************************


// Telnet settings record

#define kTSRsignature		0x518C			// proper value for signature field
#define kTSRversion			0				// current version of settings record

#if defined(powerc) || defined (__powerc)
#pragma options align=mac68k
#endif
struct TelnetSettingsRec {
	short	signature;						// ensure weve got our kind of file
	short	settingsVersion;				// version of settings record
	short	settingsMinVersion;				// minimum compatible version of settings
	char		unused[10];					// align hostname on 16-byte interval
	
	char		hostName[256];				// users name for host & port number
	char		termEmulation[48];				// IANA name of terminal emulation

	char		backspaceChar;					// character to substitute for backspace
	Boolean	closeOnSessionEnd;				// close window when session ends
	Boolean	showDebug;					// show debugging codes
};
#if defined(powerc) || defined(__powerc)
#pragma options align=reset
#endif

typedef struct TelnetSettingsRec TelnetSettingsRec;
